## net.sf.saxon.event
Class ContentHandlerProxy

    java.lang.Object
      net.sf.saxon.event.ContentHandlerProxy

All Implemented Interfaces:
  Result, Receiver

Direct Known Subclasses:
  TypedContentHandler

    public class ContentHandlerProxy

extends Object
implements Receiver

A ContentHandlerProxy is a Receiver that converts events into the form expected by an underlying SAX2 ContentHandler. Relevant events (notably comments) can also be fed to a LexicalHandler.

Note that in general the output passed to a Receiver corresponds to an External General Parsed Entity. A SAX2 ContentHandler only expects to deal with well-formed XML documents, so we only pass it the contents of the first element encountered, unless the saxon:require-well-formed output property is set to "no".

This ContentHandlerProxy provides no access to type information. For a ContentHandler that makes type information available, see `TypedContentHandler`

The ContentHandlerProxy can also be nominated as a TraceListener, to receive notification of trace events. This will be done automatically if the option setTraceListener(

Nested Class Summary
`class` `ContentHandlerProxy.ContentHandlerProxyTraceListener`

Field Summary

Fields inherited from interface javax.xml.transform.Result
`PI_DISABLE_OUTPUT_ESCAPING, PI_ENABLE_OUTPUT_ESCAPING`

Constructor Summary
`ContentHandlerProxy()`

Method Summary
`void` `attribute(int nameCode, int typeCode, CharSequence value, int locationId, int properties)` Notify an attribute.
`void` `characters(CharSequence chars, int locationId, int properties)` Character data
`void` `close()` End of document
`void` `comment(CharSequence chars, int locationId, int properties)` Output a comment.
`void` `endDocument()` Notify the end of a document node
`void` `endElement()` End of element
`Configuration` `getConfiguration()` Get the pipeline configuration
`int` `getCurrentLocationId()` Get the current location identifier
`LocationProvider` `getLocationProvider()` Get the location provider
`PipelineConfiguration` `getPipelineConfiguration()` Get the pipeline configuration
`String` `getSystemId()` Get the System ID of the destination tree
`ContentHandlerProxy.ContentHandlerProxyTraceListener` `getTraceListener()` Get the associated TraceListener that receives notification of trace events
`ContentHandler` `getUnderlyingContentHandler()` Get the underlying content handler
`void` `handleSAXException(SAXException err)` Handle a SAXException thrown by the ContentHandler
`boolean` `isRequireWellFormed()` Determine whether the content handler can handle a stream of events that is merely well-balanced, or whether it can only handle a well-formed sequence.
`boolean` `isUndeclareNamespaces()` Determine whether namespace undeclaration events (for a non-null prefix) should be notified.
`void` `namespace(int namespaceCode, int properties)` Notify a namespace.
`void` `open()` Start of document
`void` `processingInstruction(String target, CharSequence data, int locationId, int properties)` Processing Instruction
`void` `setLexicalHandler(LexicalHandler handler)` Set the Lexical Handler to be used.
`void` `setOutputProperties(Properties details)` Set the output details.
`void` `setPipelineConfiguration(PipelineConfiguration pipe)` Set the pipeline configuration
`void` `setRequireWellFormed(boolean wellFormed)` Indicate whether the content handler can handle a stream of events that is merely well-balanced, or whether it can only handle a well-formed sequence.
`void` `setSystemId(String systemId)` Set the System ID of the destination tree
`void` `setUndeclareNamespaces(boolean undeclareNamespaces)` Determine whether namespace undeclaration events (for a non-null prefix) should be notified.
`void` `setUnderlyingContentHandler(ContentHandler handler)` Set the underlying content handler.
`void` `setUnparsedEntity(String name, String systemID, String publicID)` Notify an unparsed entity URI.
`void` `startContent()` Notify the start of the content, that is, the completion of all attributes and namespaces.
`void` `startDocument(int properties)` Start of a document node.
`void` `startElement(int nameCode, int typeCode, int locationId, int properties)` Notify the start of an element

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### ContentHandlerProxy

    public ContentHandlerProxy()

Method Detail

### setUnderlyingContentHandler

    public void setUnderlyingContentHandler(ContentHandler handler)

  Set the underlying content handler. This call is mandatory before using the Emitter.

### getUnderlyingContentHandler

    public ContentHandler getUnderlyingContentHandler()

  Get the underlying content handler

### setLexicalHandler

    public void setLexicalHandler(LexicalHandler handler)

  Set the Lexical Handler to be used. If called, this must be called AFTER setUnderlyingContentHandler()

### setPipelineConfiguration

    public void setPipelineConfiguration(PipelineConfiguration pipe)

  Set the pipeline configuration

  Specified by:
    `setPipelineConfiguration` in interface `Receiver`

### getPipelineConfiguration

    public PipelineConfiguration getPipelineConfiguration()

  Get the pipeline configuration

  Specified by:
    `getPipelineConfiguration` in interface `Receiver`

### getConfiguration

    public Configuration getConfiguration()

  Get the pipeline configuration

### setSystemId

    public void setSystemId(String systemId)

  Set the System ID of the destination tree

  Specified by:
    `setSystemId` in interface `Result`
  Specified by:
    `setSystemId` in interface `Receiver`

### getSystemId

    public String getSystemId()

  Get the System ID of the destination tree

  Specified by:
    `getSystemId` in interface `Result`

### getTraceListener

    public ContentHandlerProxy.ContentHandlerProxyTraceListener getTraceListener()

  Get the associated TraceListener that receives notification of trace events

### getLocationProvider

    public LocationProvider getLocationProvider()

  Get the location provider

### getCurrentLocationId

    public int getCurrentLocationId()

  Get the current location identifier

### setUnparsedEntity

    public void setUnparsedEntity(String name,
                                  String systemID,
                                  String publicID)
                           throws XPathException

  Notify an unparsed entity URI.

  Specified by:
    `setUnparsedEntity` in interface `Receiver`
  Parameters:
    `name` - The name of the unparsed entity
    `systemID` - The system identifier of the unparsed entity
    `publicID` - The public identifier of the unparsed entity
  Throws:
    `XPathException`

### setOutputProperties

    public void setOutputProperties(Properties details)
                             throws XPathException

  Set the output details.

  Throws:
    `XPathException`

### isRequireWellFormed

    public boolean isRequireWellFormed()

  Determine whether the content handler can handle a stream of events that is merely well-balanced, or whether it can only handle a well-formed sequence.

### setRequireWellFormed

    public void setRequireWellFormed(boolean wellFormed)

  Indicate whether the content handler can handle a stream of events that is merely well-balanced, or whether it can only handle a well-formed sequence.

### isUndeclareNamespaces

    public boolean isUndeclareNamespaces()

  Determine whether namespace undeclaration events (for a non-null prefix) should be notified. The default is no, because some ContentHandlers (e.g. JDOM) can't cope with them.

  Returns:
    true if namespace undeclarations (xmlns:p="") are output

### setUndeclareNamespaces

    public void setUndeclareNamespaces(boolean undeclareNamespaces)

  Determine whether namespace undeclaration events (for a non-null prefix) should be notified. The default is no, because some ContentHandlers (e.g. JDOM) can't cope with them.

  Parameters:
    `undeclareNamespaces` - true if namespace undeclarations (xmlns:p="") are to be output

### open

    public void open()
              throws XPathException

  Start of document

  Specified by:
    `open` in interface `Receiver`
  Throws:
    `XPathException`

### close

    public void close()
               throws XPathException

  End of document

  Specified by:
    `close` in interface `Receiver`
  Throws:
    `XPathException`

### startDocument

    public void startDocument(int properties)
                       throws XPathException

  Start of a document node.

  Specified by:
    `startDocument` in interface `Receiver`
  Throws:
    `XPathException`

### endDocument

    public void endDocument()
                     throws XPathException

  Notify the end of a document node

  Specified by:
    `endDocument` in interface `Receiver`
  Throws:
    `XPathException`

### startElement

    public void startElement(int nameCode,
                             int typeCode,
                             int locationId,
                             int properties)
                      throws XPathException

  Notify the start of an element

  Specified by:
    `startElement` in interface `Receiver`
  Parameters:
    `nameCode` - integer code identifying the name of the element within the name pool.
    `typeCode` - integer code identifying the element's type within the name pool. The value -1 indicates the default type, xs:untyped.
    `locationId` - an integer which can be interpreted using a `LocationProvider` to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - bit-significant properties of the element node. If there are no revelant properties, zero is supplied.
  Throws:
    `XPathException`

### namespace

    public void namespace(int namespaceCode,
                          int properties)
                   throws XPathException

  Notify a namespace. Namespaces are notified after the startElement event, and before any children for the element.

  Specified by:
    `namespace` in interface `Receiver`
  Parameters:
    `namespaceCode` - an integer: the top half is a prefix code, the bottom half a URI code. These may be translated into an actual prefix and URI using the name pool. A prefix code of zero represents the empty prefix (that is, the default namespace). A URI code of zero represents a URI of "", that is, a namespace undeclaration.
    `properties` - The most important property is REJECT_DUPLICATES. If this property is set, the namespace declaration will be rejected if it conflicts with a previous declaration of the same prefix. If the property is not set, the namespace declaration will be ignored if it conflicts with a previous declaration. This reflects the fact that when copying a tree, namespaces for child elements are emitted before the namespaces of their parent element. Unfortunately this conflicts with the XSLT rule for complex content construction, where the recovery action in the event of conflicts is to take the namespace that comes last. XSLT therefore doesn't recover from this error: it sets the REJECT_DUPLICATES flag, and this is treated as a hard error.
  Throws:
    `XPathException`

### attribute

    public void attribute(int nameCode,
                          int typeCode,
                          CharSequence value,
                          int locationId,
                          int properties)
                   throws XPathException

  Notify an attribute. Attributes are notified after the startElement event, and before any children.

  Specified by:
    `attribute` in interface `Receiver`
  Parameters:
    `nameCode` - The name of the attribute, as held in the name pool
    `typeCode` - The type of the attribute, as held in the name pool. The additional bit NodeInfo.IS_DTD_TYPE may be set to indicate a DTD-derived type.
    `locationId` - an integer which can be interpreted using a `LocationProvider` to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Bit significant value. The following bits are defined:
  DISABLE_ESCAPING
    Disable escaping for this attribute
  NO_SPECIAL_CHARACTERS
    Attribute value contains no special characters
  Throws:
    `XPathException`

### startContent

    public void startContent()
                      throws XPathException

  Notify the start of the content, that is, the completion of all attributes and namespaces. Note that the initial receiver of output from XSLT instructions will not receive this event, it has to detect it itself. Note that this event is reported for every element even if it has no attributes, no namespaces, and no content.

  Specified by:
    `startContent` in interface `Receiver`
  Throws:
    `XPathException`

### endElement

    public void endElement()
                    throws XPathException

  End of element

  Specified by:
    `endElement` in interface `Receiver`
  Throws:
    `XPathException`

### characters

    public void characters(CharSequence chars,
                           int locationId,
                           int properties)
                    throws XPathException

  Character data

  Specified by:
    `characters` in interface `Receiver`
  Parameters:
    `chars` - The characters
    `locationId` - an integer which can be interpreted using a `LocationProvider` to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Bit significant value. The following bits are defined:
  DISABLE_ESCAPING
    Disable escaping for this text node
  USE_CDATA
    Output as a CDATA section
  NO_SPECIAL_CHARACTERS
    Value contains no special characters
  WHITESPACE
    Text is all whitespace
  Throws:
    `XPathException`

### processingInstruction

    public void processingInstruction(String target,
                                      CharSequence data,
                                      int locationId,
                                      int properties)
                               throws XPathException

  Processing Instruction

  Specified by:
    `processingInstruction` in interface `Receiver`
  Parameters:
    `target` - The PI name. This must be a legal name (it will not be checked).
    `data` - The data portion of the processing instruction
    `locationId` - an integer which can be interpreted using a `LocationProvider` to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Additional information about the PI. The following bits are defined:
  CHECKED
    Data is known to be legal (e.g. doesn't contain "?>")
  Throws:
    `XPathException`

### comment

    public void comment(CharSequence chars,
                        int locationId,
                        int properties)
                 throws XPathException

  Output a comment. Passes it on to the ContentHandler provided that the ContentHandler is also a SAX2 LexicalHandler.

  Specified by:
    `comment` in interface `Receiver`
  Parameters:
    `chars` - The content of the comment
    `locationId` - an integer which can be interpreted using a `LocationProvider` to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Additional information about the comment. The following bits are defined:
  CHECKED
    Comment is known to be legal (e.g. doesn't contain "--")
  Throws:
    `XPathException`

### handleSAXException

    public void handleSAXException(SAXException err)
                            throws XPathException

  Handle a SAXException thrown by the ContentHandler

  Throws:
    `XPathException`

Copyright (C) Michael H. Kay. All rights reserved.